-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE procedure [C6MartPeriodico].[RP_DM_ANAG_PRODOTTI_pre_selective]
AS
BEGIN
	SET NOCOUNT ON;	
	DECLARE @ID_ELAB INT
	DECLARE @TIPO_ELAB VARCHAR(1)
	SET @ID_ELAB = C6MartPeriodico.GETIDELAB()
	SET @TIPO_ELAB = C6MartPeriodico.GETTIPOELAB()
	-- Log esecuzione
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_ANAG_PRODOTTI_pre_selective',
		GETDATE(),
		'Elaborazione trimestrale'
	)
	TRUNCATE TABLE C6MartPeriodico.ANAG_PRODOTTI
	INSERT INTO [C6MartPeriodico].[ANAG_PRODOTTI]
		   (--ChiaveProdotto,
		   [COD_PRODOTTO]
		   ,[COD_ISIN]
		   ,[PAESE]
		   ,[ID_AREA]
		   ,[CAT_PRODOTTO]
		   ,[TIPO_PRODOTTO]
		   ,[DESCR_PRODOTTO]
		   ,[DIV_QUOTAZIONE]
		   ,[DIV_REGOLAMENTO]
		   ,[ID_EMITTENTE]
		   ,[MERCATO_CONTRATT]
		   ,[COD_MAF]
		   ,[RATING]
		   ,[COD_ADEGUATEZZA]
		   ,[COD_SOTTOPRODOTTO]
		   ,[COD_INTERNO]
		   ,[ID_ELAB]
		   ,[TIPO_ELAB]
           ,[DT_SCADENZA]
           ,[TIPO_EMITTENTE] 
           ,[TIPO_TASSO]
           ,[FLG_OB])
	SELECT 
		--ChiaveProdotto, 
		CatalogueID AS COD_PRODOTTO,
		ISNULL(CodIsin, '') AS COD_ISIN,
		NULL AS PAESE,
		'' AS ID_AREA,
		(SELECT CASE  
			WHEN a.Livello1 like '%Assicurativo%' THEN 'Gestito Finanziario'
         else a.Livello1
		END) AS CAT_PRODOTTO,
		TipoProdotto AS TIPO_PRODOTTO,
		NomeProdotto AS DESCR_PRODOTTO,
		PrezzoValuta AS DIV_QUOTAZIONE,
		NULL AS DIV_REGOLAMENTO,
		NULL AS ID_EMITTENTE,
		NULL AS MERCATO_CONTRATT,
		CodMaf AS COD_MAF,
		case when LTRIM(RTRIM(RATINGobbligazioni)) = '' THEN null ELSE RATINGobbligazioni end AS RATING,
		CodAdeguatezza AS COD_ADEGUATEZZA,
		CodSottoprodotto AS COD_SOTTOPRODOTTO,
		ISNULL(CodInterno, '') AS COD_INTERNO,
		@ID_ELAB AS ID_ELAB,
		@TIPO_ELAB AS TIPO_ELAB, 
        DtScadenza, 
        TIP_EMITTENTE, 
        TIP_TASSO, 
        CASE WHEN c.Alberatura = 98 THEN 'S' ELSE 'N' END AS FLG_OB
	FROM C6StagingPeriodico.RP_CatalogoProdotti  c
Inner Join C6StagingPeriodico.RP_AnAlberatura  a
	ON c.Alberatura = a.Alberatura
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_ANAG_PRODOTTI_pre_selective' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_ANAG_PRODOTTI_pre_selective'
		)
END